//+------------------------------------------------------------------+
//|                                                   TickRSI_v1.mq4 |
//|                                Copyright  2009, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_separate_window
#property indicator_buffers   1
#property indicator_color1    Lime
#property indicator_width1    2 
#property indicator_level1    50
#property indicator_level2    30
#property indicator_level3    70
#property indicator_minimum   0
#property indicator_maximum   100
//---- inputs
extern int     Price       =     0; //Applied Price(0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted)
extern int     Length      =    14; //Period of evaluation
extern int     MA_Mode     =     2; //MA Mode: 0-SMA,1-EMA,2-Wilder(SMMA),3-LWMA 
extern int     NumTicks    =     0; //TimeFrame in ticks (=0 if NumSecs  > 0)
extern int     NumSecs     =    10; //TimeFrame in secs  (=0 if NumTicks > 0) 
extern int     MaxBars     =    50; //Max Number of Bars   

double tRSI[];
double Bulls[];
double Bears[];
double AvgBulls[];
double AvgBears[];
double price[];

double   Hi;
double   Lo;
double   tOpen;
double   tClose;
int      tickCounter=0, barCounter, pSecs;
datetime pTime;
string   short_name, t;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,tRSI);
   SetIndexBuffer(1,Bulls);
   SetIndexBuffer(2,Bears);
   SetIndexBuffer(3,AvgBulls);
   SetIndexBuffer(4,AvgBears);
   SetIndexBuffer(5,price);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(NumTicks > 0) t = NumTicks +" Ticks] ";
   if(NumSecs  > 0) t = NumSecs  +" Secs] ";
   short_name="TickRSI_v1 ["+t+"("+Price+","+Length+","+MA_Mode+","+MaxBars+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"TickRSI");
      
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
        
   pTime = Time[0];
   pSecs = TimeCurrent();       
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
//----
   return(0);
}

void ShiftArray(int mode)
{
   if(mode==0)
   {
      for(int cnt=barCounter; cnt >= 0; cnt--)
      {
      tRSI [cnt] = tRSI[cnt-1];
      Bulls [cnt] = Bulls[cnt-1];
      Bears [cnt] = Bears[cnt-1];
      AvgBulls [cnt] = AvgBulls[cnt-1];
      AvgBears [cnt] = AvgBears[cnt-1];
      price [cnt] = price[cnt-1];
      }
   }
   else
   {
      for(cnt=1; cnt <= barCounter; cnt++)
      {
      tRSI [cnt-1] = tRSI[cnt];
      Bulls [cnt-1] = Bulls[cnt];
      Bears [cnt-1] = Bears[cnt];
      AvgBulls [cnt-1] = AvgBulls[cnt];
      AvgBears [cnt-1] = AvgBears[cnt];
      price [cnt-1] = price[cnt];
          
      tRSI[cnt] = 0.0;
      Bulls [cnt] = 0.0;
      Bears [cnt] = 0.0;
      AvgBulls [cnt] = 0.0;
      AvgBears [cnt] = 0.0;
      price[cnt] = 0.0;
      }
   }
}

bool isNewBar()
{
   bool res=false;
   if (Time[0]!=pTime)
   {
   res=true;
   pTime=Time[0];
   }   

   return(res);
}

double aPrice(int p)
{
   double result;
   switch(p)
   {
   case 1 : result = tOpen; break;
   case 2 : result = Hi; break;
   case 3 : result = Lo; break;
   case 4 : result = (Hi+Lo)/2; break;
   case 5 : result = (Hi+Lo+tClose)/3; break;
   case 6 : result = (Hi+Lo+tClose+tClose)/4; break;
   default: result = tClose; 
   }
   
   return(result);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,cnt_bars = IndicatorCounted();
   
   if(cnt_bars < 1) //tickCounter == 0)
   {
      for(i=Bars-1;i>=0;i--)
      {
      tRSI[i] = 0.0;
      }
   }
   
   tickCounter++;
   
   bool tcond = false;   
   if(NumTicks > 0 && NumSecs == 0) tcond = tickCounter > 0 && tickCounter % NumTicks == 0;
   if(NumTicks == 0 && NumSecs > 0) tcond = TimeCurrent() >= pSecs + NumSecs;
   
   if(tcond) 
   {
   barCounter ++; 
   if(!isNewBar()) ShiftArray(0);
   tOpen =Bid;
   tClose=Bid;
   Hi    =Bid;
   Lo    =Bid; 
   price[0] = aPrice(Price); 
   if(NumSecs > 0) pSecs = TimeCurrent();
   }
   
   if(barCounter>=1)
   {
   if(isNewBar()) ShiftArray(1);
   tClose=Bid;
   Hi    =MathMax(Hi,Bid);
   if(Lo > 0) Lo=MathMin(Lo,Bid); else Lo=Bid;
   price[0] = aPrice(Price); 
   }
   
   if(barCounter >= MaxBars) 
   {
      for(i=MaxBars; i<MaxBars+10;i++)
      { 
      tRSI[i]=0.0;
      }
   }
   
   Bulls[0] = MathAbs(price[0]-price[1])+(price[0]-price[1]);
   Bears[0] = MathAbs(price[0]-price[1])-(price[0]-price[1]);   
   
   int len = Length;
   if(MA_Mode == 2) len = 2*Length - 1;
   
   if(barCounter > len)
   {
      if(MA_Mode == 0)
      {
      AvgBulls[0] = TickSMA(Bulls, len);          
      AvgBears[0] = TickSMA(Bears, len);
      }   
      else
      if(MA_Mode == 1 || MA_Mode == 2)
      {
         if(barCounter == len+1)
         { 
         AvgBulls[0] = TickSMA(Bulls, len);          
         AvgBears[0] = TickSMA(Bears, len);  
         }
         else 
         if(barCounter > len+1)
         { 
         AvgBulls[0] = TickEMA(Bulls, AvgBulls, len);
         AvgBears[0] = TickEMA(Bears, AvgBears, len);
         }
      }
      else
      if(MA_Mode == 3)
      {
      AvgBulls[0] = TickLWMA(Bulls, len);          
      AvgBears[0] = TickLWMA(Bears, len);
      }   
   
   if (AvgBulls[0] != 0) 
   tRSI[0] = 100.0/(1+AvgBears[0]/AvgBulls[0]);
   else tRSI[0] = 0.00000001;        
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
double TickSMA(double& array[],int per)
{
   double Sum = 0;
   for(int i = 0;i < per;i++) {Sum += array[i];
   if(array[i]==0) Print("i=",i," a=",array[i]);}
   return(Sum/per);
}                

double TickEMA(double& array1[],double& array2[],int per)
{
   return(array2[1] + 2.0/(1+per)*(array1[0] - array2[1]));
}

double TickLWMA(double& array[],int per)
{
   double Sum = 0;
   double Weight = 0;
   
      for(int i = 0;i < per;i++)
      { 
      Weight+= (per - i);
      Sum += array[i]*(per - i);
      }
   if(Weight>0) double lwma = Sum/Weight;
   else lwma = 0; 
   return(lwma);
}                          